﻿using System.Collections;
using TMPro;
using UltimateWater;
using UnityEngine;
using UnityEngine.UI;

public class QuestItems : Mod
{
    public static QuestItems Instance;
    public static Material colliderShader;
    private AssetBundle asset;
    private GameObject cc;
    private Button close;
    private Button Give;
    private Button NVM;
    private Button Plus, Minus;
    private Button Blue, Green, Red, Crowbar, Recorder, MechanicalC;
    private Button BulletinBottle, Key_Card, Four_Digit_Code, Gas_Tank, Bolt_Cutter, Electrical_Wires;
    private Button Lighter, Car_Jack, Bomb;
    private Button Brunos_Hammer, Brunos_Saw, Brunos_Wrench, Lightbulb, Wild_Berries;
    private Button Battery_Charger_Part, KeyInfirmary, Mayors_Chest_Key, Zipline_Part;
    private Button Generator_Part, Tangaroa_Keycard, Tangaroa_Token, Tape;
    private TMP_InputField HowMuch;
    private Canvas menu;
    private TextMeshProUGUI Name, From;

    public void Start()
    {
        Instance = this;

        StartCoroutine(LoadAssets());
        Debug.Log("QuestItems has been loaded!");
    }
    public void OnModUnload()
    {
        if (asset != null)
            asset.Unload(true);
        StopAllCoroutines();
        Debug.Log("QuestItems has been unloaded!");
        RAPI.ToggleCursor(false);
        cc.SetActive(false);
        Destroy(cc);
    }

    public void Update()
    {
        LoadIt();
    }

    private IEnumerator LoadAssets()
    {
        AssetBundleCreateRequest bundleRequest = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("questitems.asset"));
        yield return bundleRequest;
        asset = bundleRequest.assetBundle;
        var prefab = asset.LoadAsset<GameObject>("Canvas");
        cc = Instantiate(prefab, transform);
        menu = cc.GetComponent<Canvas>();
        cc.SetActive(false);

        close = menu.transform.Find("Background").Find("Top").Find("Exit").GetComponent<Button>();

        Name = menu.transform.Find("Background").Find("Info").Find("Name").Find("ItemName").GetComponent<TextMeshProUGUI>();
        From = menu.transform.Find("Background").Find("Info").Find("From").Find("IslandName").GetComponent<TextMeshProUGUI>();

        NVM = menu.transform.Find("Nop").GetComponent<Button>();

        HowMuch = menu.transform.Find("Background").Find("Info").Find("HowMuch").GetComponent<TMP_InputField>();
        Give = menu.transform.Find("Background").Find("Info").Find("Give").GetComponent<Button>();

        Plus = menu.transform.Find("Background").Find("Info").Find("Plus").GetComponent<Button>();
        Minus = menu.transform.Find("Background").Find("Info").Find("Minus").GetComponent<Button>();

        var Vasagatan = menu.transform.Find("Background").Find("Items").Find("Palace").Find("Vasagatan").Find("Vasagatan");
        var Balboa = menu.transform.Find("Background").Find("Items").Find("Palace").Find("Balboa").Find("Balboa");
        var Caravan = menu.transform.Find("Background").Find("Items").Find("Palace").Find("Caravan").Find("Caravan");
        var Tangaroa = menu.transform.Find("Background").Find("Items").Find("Palace").Find("Tangaroa").Find("Tangaroa");

        var Row1 = Vasagatan.Find("Row1");
        var Row2 = Vasagatan.Find("Row2");
        var Row3 = Vasagatan.Find("Row3");

        Blue = Row1.Find("Blue_Key").GetComponent<Button>();
        Green = Row1.Find("Green_Key").GetComponent<Button>();
        Red = Row1.Find("Red_Key").GetComponent<Button>();
        Crowbar = Row1.Find("Crowbar").GetComponent<Button>();
        Recorder = Row1.Find("Recorder").GetComponent<Button>();
        MechanicalC = Row1.Find("Mechanical_Component").GetComponent<Button>();

        BulletinBottle = Row2.Find("BulletinBottle").GetComponent<Button>();
        Key_Card = Row2.Find("Key_Card").GetComponent<Button>();
        Four_Digit_Code = Row2.Find("Four_Digit_Code").GetComponent<Button>();
        Gas_Tank = Row2.Find("Gas_Tank").GetComponent<Button>();
        Bolt_Cutter = Row2.Find("Bolt_Cutter").GetComponent<Button>();
        Electrical_Wires = Row2.Find("Electrical_Wires").GetComponent<Button>();

        Lighter = Row3.Find("Lighter").GetComponent<Button>();
        Car_Jack = Row3.Find("Car_Jack").GetComponent<Button>();
        Bomb = Row3.Find("Bomb").GetComponent<Button>();

        Brunos_Hammer = Balboa.Find("Brunos_Hammer").GetComponent<Button>();
        Brunos_Saw = Balboa.Find("Brunos_Saw").GetComponent<Button>();
        Brunos_Wrench = Balboa.Find("Brunos_Wrench").GetComponent<Button>();
        Lightbulb = Balboa.Find("Lightbulb").GetComponent<Button>();
        Wild_Berries = Balboa.Find("Wild_Berries").GetComponent<Button>();

        Battery_Charger_Part = Caravan.Find("Battery_Charger_Part").GetComponent<Button>();
        KeyInfirmary = Caravan.Find("KeyInfirmary").GetComponent<Button>();
        Mayors_Chest_Key = Caravan.Find("Mayors_Chest_Key").GetComponent<Button>();
        Zipline_Part = Caravan.Find("Zipline_Part").GetComponent<Button>();

        Generator_Part = Tangaroa.Find("Generator_Part").GetComponent<Button>();
        Tangaroa_Keycard = Tangaroa.Find("Tangaroa_Keycard").GetComponent<Button>();
        Tangaroa_Token = Tangaroa.Find("Tangaroa_Token").GetComponent<Button>();
        Tape = Tangaroa.Find("Tape").GetComponent<Button>();

        ButtonClicked();
    }

    public void LoadIt()
    {
        if (Semih_Network.InMenuScene) return;
        if (cc == null)
        {
            return;
        }
        if (Input.GetKeyDown(KeyCode.Escape))
        {
            if (cc.activeSelf)
            {
                cc.SetActive(false);
                RAPI.ToggleCursor(false);
                Name.text = "Nothing";
                From.text = "NoWhere";
                HowMuch.text = "1";
            }
        }
        if (cc.activeSelf)
        {
            if (HowMuch.text == "0")
            {
                HowMuch.text = "1";
            }
            if (HowMuch.verticalScrollbar) HowMuch.verticalScrollbar.enabled = false;
        }
    }
    private void ButtonClicked()
    {
        close.onClick.AddListener(Close);

        Blue.onClick.AddListener(() =>
        {
            Name.text = "Blue Key";
            From.text = "Vasagatan";
            HowMuch.text = "1";
        });
        Green.onClick.AddListener(() =>
        {
            Name.text = "Green Key";
            From.text = "Vasagatan";
            HowMuch.text = "1";
        });
        Red.onClick.AddListener(() =>
        {
            Name.text = "Red Key";
            From.text = "Vasagatan";
            HowMuch.text = "1";
        });
        Crowbar.onClick.AddListener(() =>
        {
            Name.text = "Crowbar";
            From.text = "Vasagatan";
            HowMuch.text = "1";
        });
        Recorder.onClick.AddListener(() =>
        {
            Name.text = "Recorder ( Bugged, Not Fixed )";
            From.text = "Vasagatan";
            HowMuch.text = "1";
        });
        MechanicalC.onClick.AddListener(() =>
        {
            Name.text = "Mechanical Component";
            From.text = "Vasagatan";
            HowMuch.text = "1";
        });
        BulletinBottle.onClick.AddListener(() =>
        {
            Name.text = "Bullet";
            From.text = "Vasagatan";
            HowMuch.text = "1";
        });
        Key_Card.onClick.AddListener(() =>
        {
            Name.text = "Keycard";
            From.text = "Vasagatan";
            HowMuch.text = "1";
        });
        Four_Digit_Code.onClick.AddListener(() =>
        {
            Name.text = "Four Digit Code";
            From.text = "Vasagatan";
            HowMuch.text = "1";
        });
        Gas_Tank.onClick.AddListener(() =>
        {
            Name.text = "Gas Tank";
            From.text = "Vasagatan";
            HowMuch.text = "1";
        });
        Bolt_Cutter.onClick.AddListener(() =>
        {
            Name.text = "Bolt Cutter";
            From.text = "Vasagatan";
            HowMuch.text = "1";
        });
        Electrical_Wires.onClick.AddListener(() =>
        {
            Name.text = "Electrical Wires";
            From.text = "Vasagatan";
            HowMuch.text = "1";
        });
        Lighter.onClick.AddListener(() =>
        {
            Name.text = "Lighter";
            From.text = "Vasagatan";
            HowMuch.text = "1";
        });
        Car_Jack.onClick.AddListener(() =>
        {

            Name.text = "Car Jack";
            From.text = "Vasagatan";
            HowMuch.text = "1";
        });
        Bomb.onClick.AddListener(() =>
        {
            Name.text = "Bomb";
            From.text = "Vasagatan";
            HowMuch.text = "1";
        });



        Brunos_Hammer.onClick.AddListener(() =>
        {
            Name.text = "Brunos Hammer";
            From.text = "Balboa";
            HowMuch.text = "1";
        });
        Brunos_Saw.onClick.AddListener(() =>
        {
            Name.text = "Brunos Saw";
            From.text = "Balboa";
            HowMuch.text = "1";
        });
        Brunos_Wrench.onClick.AddListener(() =>
        {
            Name.text = "Brunos Wrench";
            From.text = "Balboa";
            HowMuch.text = "1";
        });
        Lightbulb.onClick.AddListener(() =>
        {
            Name.text = "Lightbulb";
            From.text = "Balboa";
            HowMuch.text = "1";
        });
        Wild_Berries.onClick.AddListener(() =>
        {
            Name.text = "Wild Berries";
            From.text = "Balboa";
            HowMuch.text = "1";
        });



        Battery_Charger_Part.onClick.AddListener(() =>
        {
            Name.text = "Battery Charger Part";
            From.text = "Caravan";
            HowMuch.text = "1";
        });
        Zipline_Part.onClick.AddListener(() =>
        {
            Name.text = "Zipline Part";
            From.text = "Caravan";
            HowMuch.text = "1";
        });
        KeyInfirmary.onClick.AddListener(() =>
        {
            Name.text = "Infirmary Key";
            From.text = "Caravan";
            HowMuch.text = "1";
        });
        Mayors_Chest_Key.onClick.AddListener(() =>
        {
            Name.text = "Mayor's Chest Key";
            From.text = "Caravan";
            HowMuch.text = "1";
        });



        Generator_Part.onClick.AddListener(() =>
        {
            Name.text = "Generator Part";
            From.text = "Tangaroa";
            HowMuch.text = "1";
        });
        Tangaroa_Keycard.onClick.AddListener(() =>
        {
            Name.text = "Keycard";
            From.text = "Tangaroa";
            HowMuch.text = "1";
        });
        Tangaroa_Token.onClick.AddListener(() =>
        {
            Name.text = "Token";
            From.text = "Tangaroa";
            HowMuch.text = "1";
        });
        Tape.onClick.AddListener(() =>
        {
            Name.text = "Duct Tape";
            From.text = "Tangaroa";
            HowMuch.text = "1";
        });


        Plus.onClick.AddListener(() =>
        {
            if (HowMuch.text == "")
            {
                HowMuch.text = "1";
            }
            var HowM = int.Parse(HowMuch.text);
            if (HowM == 999) return;
            HowM = HowM + 1;
            HowMuch.text = HowM.ToString();
        });

        Minus.onClick.AddListener(() =>
        {
            if (HowMuch.text == "")
            {
                HowMuch.text = "1";
            }
            var HowM = int.Parse(HowMuch.text);
            if (HowM == 1) return;
            HowM = HowM - 1;
            HowMuch.text = HowM.ToString();
        });


        NVM.onClick.AddListener(() =>
        {
            Name.text = "Nothing";
            From.text = "NoWhere";
            HowMuch.text = "1";
        });



        Give.onClick.AddListener(() =>
        {
            if (cc.activeSelf)
            {
                if (HowMuch.text == "")
                {
                    HowMuch.text = "1";
                }
            }
            var n = Name.text;
            var f = From.text;
            var HowM = int.Parse(HowMuch.text);
            if (f == "NoWhere" && n == "Nothing")
            {
                FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "I wonder what quest items you need...", 3, HNotify.ErrorSprite);
            }
            if (f == "Vasagatan")
            {
                if (n == "Blue Key")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Vasagatan_BlueKey), HowM) });
                }
                else if (n == "Green Key")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Vasagatan_GreenKey), HowM) });
                }
                else if (n == "Red Key")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Vasagatan_RedKey), HowM) });
                }
                else if (n == "Crowbar")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Vasagatan_Crowbar), HowM) });
                }
                else if (n == "Recorder")
                {
                    FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "Bug Reported on this item, please wait till it's fixed. Thank you", 3, HNotify.ErrorSprite);
                }
                else if (n == "Mechanical Component")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Vasagatan_MechanicalPart), HowM) });
                }
                else if (n == "Bullet")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Vasagatan_Bullet), HowM) });
                }
                else if (n == "Keycard")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Vasagatan_KeyCard), HowM) });
                }
                else if (n == "Four Digit Code")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Vasagatan_FourDigitCode), HowM) });
                }
                else if (n == "Gas Tank")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Vasagatan_GasTank), HowM) });
                }
                else if (n == "Bolt Cutter")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Vasagatan_BoltCutter), HowM) });
                }
                else if (n == "Electrical Wires")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Vasagatan_BombWire), HowM) });
                }
                else if (n == "Lighter")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Vasagatan_Lighter), HowM) });
                }
                else if (n == "Car Jack")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Vasagatan_CarJack), HowM) });
                }
                else if (n == "Bomb")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Vasagatan_Bomb), HowM) });
                }
            }
            else if (f == "Balboa")
            {
                if (n == "Brunos Hammer")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Balboa_BrunosTool_Hammer), HowM) });
                }
                else if (n == "Brunos Saw")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Balboa_BrunosTool_Saw), HowM) });
                }
                else if (n == "Brunos Wrench")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Balboa_BrunosTool_Wrench), HowM) });
                }
                else if (n == "Lightbulb")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Balboa_LightBulb), HowM) });
                }
                else if (n == "Wild Berries")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Balboa_WildBerries), HowM) });
                }
            }
            else if (f == "Caravan")
            {
                if (n == "Battery Charger Part")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Caravan_BatteryChargerPart), HowM) });
                }
                else if (n == "Zipline Part")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Caravan_ZiplinePart), HowM) });
                }
                else if (n == "Infirmary Key")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Caravan_KeyInfirmary), HowM) });
                }
                else if (n == "Mayor's Chest Key")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Caravan_KeyMayor), HowM) });
                }
            }
            else if (f == "Tangaroa")
            {
                if (n == "Generator Part")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Tangaroa_GeneratorPart), HowM) });
                }
                else if (n == "Duct Tape")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Tangaroa_Tape), HowM) });
                }
                else if (n == "Keycard")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Tangaroa_KeyCard), HowM) });
                }
                else if (n == "Token")
                {
                    ComponentManager<QuestItemManager>.Value.AddQuestItemsNetworked(true, new QuestItem[] { new QuestItem(QuestItemManager.GetSOQuestItemFromType(QuestItemType.Tangaroa_Token), HowM) });
                }
            }

        });
    }

    public void Close()
    {
        cc.SetActive(false);
        RAPI.ToggleCursor(false);
        Name.text = "Nothing";
        From.text = "NoWhere";
        HowMuch.text = "1";
    }
    [ConsoleCommand(name: "ShowQI", docs: "Show QuestItems GUI")]
    public static void RegisterCommands()
    {
        Instance.ShowGUI();
    }

    public void ShowGUI()
    {
        if (Semih_Network.InMenuScene)
        {
            return;
        }
        if (cc == null)
            InstantiateCanvas();
        else
        {
            if (cc.activeInHierarchy)
            {
                cc.SetActive(false);
                RAPI.ToggleCursor(false);
            }
            else
            {
                cc.SetActive(true);
                RAPI.ToggleCursor(true);
            }
        }
    }
    private void InstantiateCanvas()
    {
        var prefab = asset.LoadAsset<GameObject>("Canvas");
        cc = (GameObject)Instantiate(prefab);
    }
}